'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _asyncFile = require('async-file');

var fs = _interopRequireWildcard(_asyncFile);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _constants = require('./constants');

var _constants2 = _interopRequireDefault(_constants);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

require('babel-polyfill');

var cachedLocalCopy = null;
var cachedOnlineCopy = null;
var cachedOnlineTimestamp = null;

var getLocal = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (cachedLocalCopy) {
              _context.next = 4;
              break;
            }

            _context.next = 3;
            return fs.readFile(_path2.default.resolve(__dirname, 'vendor/blns.json'));

          case 3:
            cachedLocalCopy = _context.sent;

          case 4:
            return _context.abrupt('return', cachedLocalCopy);

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function getLocal() {
    return _ref.apply(this, arguments);
  };
}();

var getOnline = function () {
  var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
    var result;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (cachedOnlineTimestamp && cachedOnlineTimestamp.diff(_moment2.default, 'seconds') > _constants2.default.CONFIG.CACHE_LIFETIME) {
              cachedOnlineCopy = null;
            }

            if (cachedOnlineCopy) {
              _context2.next = 15;
              break;
            }

            _context2.prev = 2;
            _context2.next = 5;
            return _axios2.default.get(_constants2.default.BLNS_URL);

          case 5:
            result = _context2.sent;

            cachedOnlineCopy = result.data;
            cachedOnlineTimestamp = (0, _moment2.default)();
            _context2.next = 15;
            break;

          case 10:
            _context2.prev = 10;
            _context2.t0 = _context2['catch'](2);
            _context2.next = 14;
            return getLocal();

          case 14:
            cachedOnlineCopy = _context2.sent;

          case 15:
            return _context2.abrupt('return', cachedOnlineCopy);

          case 16:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined, [[2, 10]]);
  }));

  return function getOnline() {
    return _ref2.apply(this, arguments);
  };
}();

var NaughtyChecker = function () {
  function NaughtyChecker() {
    _classCallCheck(this, NaughtyChecker);
  }

  _createClass(NaughtyChecker, [{
    key: 'validate',
    value: function () {
      var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3() {
        var text = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { useLocal: false };
        var result;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                result = null;

                if (!options.useLocal) {
                  _context3.next = 7;
                  break;
                }

                _context3.next = 4;
                return getLocal();

              case 4:
                result = _context3.sent;
                _context3.next = 10;
                break;

              case 7:
                _context3.next = 9;
                return getOnline();

              case 9:
                result = _context3.sent;

              case 10:
                if (!result.includes(text)) {
                  _context3.next = 14;
                  break;
                }

                throw new Error(_constants2.default.ERROR.FOUND_NAUGHTY_STRING);

              case 14:
                return _context3.abrupt('return', true);

              case 15:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function validate() {
        return _ref3.apply(this, arguments);
      }

      return validate;
    }()
  }, {
    key: 'validateAll',
    value: function () {
      var _ref4 = _asyncToGenerator(regeneratorRuntime.mark(function _callee4() {
        var texts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { useLocal: false };

        var requests, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, text, results;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (!(!cachedOnlineCopy && !options.useLocal)) {
                  _context4.next = 3;
                  break;
                }

                _context4.next = 3;
                return getOnline();

              case 3:
                requests = [];
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context4.prev = 7;

                for (_iterator = texts[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  text = _step.value;

                  requests.push(this.validate(text, options));
                }
                _context4.next = 15;
                break;

              case 11:
                _context4.prev = 11;
                _context4.t0 = _context4['catch'](7);
                _didIteratorError = true;
                _iteratorError = _context4.t0;

              case 15:
                _context4.prev = 15;
                _context4.prev = 16;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 18:
                _context4.prev = 18;

                if (!_didIteratorError) {
                  _context4.next = 21;
                  break;
                }

                throw _iteratorError;

              case 21:
                return _context4.finish(18);

              case 22:
                return _context4.finish(15);

              case 23:
                _context4.next = 25;
                return Promise.all(requests);

              case 25:
                results = _context4.sent;
                return _context4.abrupt('return', results.length === requests.length);

              case 27:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this, [[7, 11, 15, 23], [16,, 18, 22]]);
      }));

      function validateAll() {
        return _ref4.apply(this, arguments);
      }

      return validateAll;
    }()
  }]);

  return NaughtyChecker;
}();

exports.default = NaughtyChecker;
module.exports = exports['default'];